--Freemarker Template
<#include "SQL_lingua_franca"/>
<#include "SuperX_general"/>
--Kopiert Studierendendaten eines Beispielsemesters WiSe 2023/2024 
--mit Stichtag amtl. Statistik zum BaWue-Semesterberichts-Stichtag Studierendenstatistik (Land)
--Nützlich wenn man die Studierendendaten bereits eingefroren hat

--Für SOS Modul 1.3 oder höher
--Das Script läuft unter Postgres und Informix mit DOSQL
--Man kann es auch mehrmals ausführen, es fügt nur dann Daten ein wenn noch keine da sind.

--Wichtig: danach muss man das Berechnen Häkchen in KENN Stichtag "Studierendenstatistik (Land)" nochmal einmalig 
--setzen und die KENN-HLR laufen lassen. Danach kann man es wieder entfernen.


<@selectintotmp source="sos_stg_aggr" target="tmp_stg" select="tid_stg,
       ca12_staat,
       geschlecht,
       alter,
       hzbart,
       hmkfzkz,
       hmkfz,
       semkfzkz,
       semkfz,
       hzbkfzkz,
       hzbkfz,
       hrst,
       studiengang_nr,
       fach_nr,
       fach_sem_zahl,
       sem_rueck_beur_ein,
       kz_rueck_beur_ein,
       klinsem,
       hssem,
       stuart,
       stutyp,
       stufrm,
       stichtag,
       summe,
       hzbart_int,
       matrikel_nr,
       ch27_grund_beurl,
       ch62_grund_exmatr,
       hzbnote,
       pseudonym,
       sem_rueck_beur_ein_max,
       ruebeudat,
       semgewicht,
       d_exmatr,
       second_nationality,
       district_astat,
       country_astat,
       practical_sem_zahl,
       kolleg_sem_zahl,
       study_related_job,
       study_related_internship,
       discontinuation_sem_zahl,
       study_interruption_type,
       field_of_study,
       ects,
       orgrole_valid_from,
       orgrole_valid_to,
       geb_gezahlt,
       aktiv,
       individual_number_of_semesters,
       ersthzbkfz,
       ersthzbkfzkz,
       ersthzbart,
       ersthzbjahr,
       ersthzbnote"
>
where sem_rueck_beur_ein=20232
and stichtag=(select S.tid from sos_stichtag S where appl_key='1')
 </@selectintotmp> <@informixnolog/>;
 
insert into sos_stg_aggr(tid_stg,
       ca12_staat,
       geschlecht,
       alter,
       hzbart,
       hmkfzkz,
       hmkfz,
       semkfzkz,
       semkfz,
       hzbkfzkz,
       hzbkfz,
       hrst,
       studiengang_nr,
       fach_nr,
       fach_sem_zahl,
       sem_rueck_beur_ein,
       kz_rueck_beur_ein,
       klinsem,
       hssem,
       stuart,
       stutyp,
       stufrm,
       stichtag,
       summe,
       hzbart_int,
       matrikel_nr,
       ch27_grund_beurl,
       ch62_grund_exmatr,
       hzbnote,
       pseudonym,
       sem_rueck_beur_ein_max,
       ruebeudat,
       semgewicht,
       d_exmatr,
       second_nationality,
       district_astat,
       country_astat,
       practical_sem_zahl,
       kolleg_sem_zahl,
       study_related_job,
       study_related_internship,
       discontinuation_sem_zahl,
       study_interruption_type,
       field_of_study,
       ects,
       orgrole_valid_from,
       orgrole_valid_to,
       geb_gezahlt,
       aktiv,
       individual_number_of_semesters,
       ersthzbkfz,
       ersthzbkfzkz,
       ersthzbart,
       ersthzbjahr,
       ersthzbnote
       )
       select tid_stg,
       ca12_staat,
       geschlecht,
       alter,
       hzbart,
       hmkfzkz,
       hmkfz,
       semkfzkz,
       semkfz,
       hzbkfzkz,
       hzbkfz,
       hrst,
       studiengang_nr,
       fach_nr,
       fach_sem_zahl,
       sem_rueck_beur_ein,
       kz_rueck_beur_ein,
       klinsem,
       hssem,
       stuart,
       stutyp,
       stufrm,
       I.tid as stichtag,
       summe,
       hzbart_int,
       matrikel_nr,
       ch27_grund_beurl,
       ch62_grund_exmatr,
       hzbnote,
       pseudonym,
       sem_rueck_beur_ein_max,
       ruebeudat,
       semgewicht,
       d_exmatr,
       second_nationality,
       district_astat,
       country_astat,
       practical_sem_zahl,
       kolleg_sem_zahl,
       study_related_job,
       study_related_internship,
       discontinuation_sem_zahl,
       study_interruption_type,
       field_of_study,
       ects,
       orgrole_valid_from,
       orgrole_valid_to,
       geb_gezahlt,
       aktiv,
       individual_number_of_semesters,
       ersthzbkfz,
       ersthzbkfzkz,
       ersthzbart,
       ersthzbjahr,
       ersthzbnote
       from tmp_stg, sos_stichtag I
       where I.appl_key='6'
       and 0=(select count(*) from sos_stg_aggr S2, sos_stichtag I2
       where S2.stichtag=I2.tid
       and S2.sem_rueck_beur_ein=tmp_stg.sem_rueck_beur_ein
       and I2.appl_key='6');
       
drop table tmp_stg;

